#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Aug 21 22:54:17 2022

@author: ad
"""

from threading import Thread
from moviepy.editor import *
import pygame

# les programmes écrits par les shadoks et les gibis pour faire décoller leurs fusées
import shadok as SH
import gibi as GB

VERBOSE = False # pour mode bavard
modeTest = False
# initialisation de la fenetre de jeu
pygame.init()
pygame.display.init()
win = pygame.display.set_mode((800,800),pygame.RESIZABLE)
pygame.display.set_caption("fusee")
vignette = pygame.image.load("img/pump2.png").convert()
pygame.display.set_icon(vignette)
pygame.mixer.init()
simul = True

# couleurs et police des textes
BLUE = (40, 120, 230)
GREEN = (40, 230, 120)
font = pygame.font.SysFont('Comic Sans MS,Arial', 24) 
fontpetit = pygame.font.SysFont('Comic Sans MS,Arial', 15)

# video introduction

def sequenceIntro() :
    texteIntro = font.render("Pour zapper l'introduction, cliquez sur la croix." , True, BLUE)
    texteIntro_rect = texteIntro.get_rect(center=(400, 300))
    win.fill(0)
    win.blit(texteIntro, texteIntro_rect)
    pygame.display.flip()
    pygame.time.delay(2500)

    clip = VideoFileClip('img/intro5.mp4')
    clip.preview()
                





# Choix de la ligne d'arrivée 

def choixArrivee():
    entier = False
    while not entier :
        global hauteurArrivee
        center_x, center_y = 350, 400
        clock = pygame.time.Clock()
        
        prompt = fontpetit.render('La terre se déplace entre 1000 et 5000 unités de shadoks ! ', True, BLUE)
        prompt2 = fontpetit.render('Choisissez la distance à la terre au départ des fusées : ', True, BLUE)
        prompt_rect = prompt.get_rect(center=(center_x, center_y))
        prompt_rect2 = prompt.get_rect(center=(center_x, center_y+30))
         
        user_input_value = ""
        user_input = font.render(user_input_value, True, GREEN)
        user_input_rect = user_input.get_rect(topleft=prompt_rect2.topright)
         
        continuer = True
         
        while continuer:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    #pygame.quit()
                    continuer = False
                    break
                elif event.type == pygame.KEYDOWN:
                    if event.key in (pygame.K_RETURN, pygame.K_KP_ENTER):
                        continuer = False
                        break
                    elif event.key == pygame.K_BACKSPACE:
                        user_input_value = user_input_value[:-1]
                    else:
                        user_input_value += event.unicode
                    user_input = font.render(user_input_value, True, GREEN)
                    user_input_rect = user_input.get_rect(topleft=prompt_rect2.topright)
         
            clock.tick(30)
         
            win.fill(0)
            win.blit(prompt, prompt_rect)
            win.blit(prompt2, prompt_rect2)
            win.blit(user_input, user_input_rect)
            pygame.display.flip()
            if VERBOSE :
                print(user_input_value)
        # verification que l'utilisateur a entré un entier
        try :
            test = int(user_input_value)
            if 1000 <= test <= 5000 :
                it_is = True
            else :
                it_is = False
            
        except ValueError:
            it_is = False
        if it_is :
            hauteurArrivee = int(user_input_value)/10 #ligne d'arrivée
            entier = True
        
        
        if VERBOSE and it_is :
            print("hauteur arrivee" + str(hauteurArrivee))
            print("La valeur de l'utilisateur convertie en entier est:", int(user_input_value))
     
def rebour() : 
    #drawGame()
    moteur = pygame.mixer.music.load("img/moteur.ogg")
    pygame.mixer.music.play(10, 0.0)
    
    clock = pygame.time.Clock()
    pump1I = pygame.image.load("img/pump1.png").convert_alpha() 
    pump2I = pygame.image.load("img/pump2.png").convert_alpha()
    gibiI = pygame.image.load("img/gibi.png").convert_alpha()
    pump_index = 0
    counter = 5
    text = '5'.rjust(3)
    pygame.time.set_timer(pygame.USEREVENT, 1000)
    font3 = pygame.font.SysFont('Consolas', 30)
    
    compter = True
    while compter:
        for e in pygame.event.get():
            if e.type == pygame.USEREVENT: 
                counter -= 1
                if counter > 0 :
                    text = str(counter).rjust(3) 
                else :
                    compter = False
            if e.type == pygame.QUIT : 
                break
            else:
                pump_index = (pump_index + 1) % 2
                if VERBOSE :
                    print(pump_index)
                win.fill((0, 0, 0))
                if pump_index == 0 :
                    win.blit(pump1I,(200,750))
                else :
                    win.blit(pump2I,(200,750))
                win.blit(gibiI,(475,750))
                win.blit(imageShadok,(300,700))
                #pygame.draw.rect(win, (255, 0, 0), (500,700-hauteurGibi, 20, 20))
                win.blit(imageGibi,(400,700))
                win.blit(imageTerre,(275,700-hauteurArrivee-140))
                #win.fill((255, 255, 255))
                win.blit(font3.render(text, True, BLUE), (350, 600))
                pygame.display.flip()
                clock.tick(60)
                continue
    pygame.mixer.music.stop()





# La course
run = True
hauteurShadok = 0 #ligne départ
hauteurGibi = 0  

imageShadok = pygame.image.load("img/fuseeShadokR.png").convert_alpha() 
imageGibi = pygame.image.load("img/fuseeGibiR.png").convert_alpha() 
imageTerre = pygame.image.load("img/terreR.png").convert_alpha() 
pygame.mixer.music.set_volume(1)
 


def fuseeS():
    global hauteurShadok
    hauteurShadok = SH.fuseeS(hauteurShadok*10)/10
    #hauteurShadok = SH.fuseeS(hauteurShadok)

def fuseeG():
    global hauteurGibi
    hauteurGibi = GB.fuseeG(hauteurGibi*10)/10
    #hauteurGibi = GB.fuseeG(hauteurGibi)
    
def drawGame():
          win.fill((0, 0, 0))
          #pygame.draw.rect(win, (0, 0, 255), (100,700-hauteurShadok, 20, 20))
          win.blit(imageShadok,(300,700-hauteurShadok))
          #pygame.draw.rect(win, (255, 0, 0), (500,700-hauteurGibi, 20, 20))
          win.blit(imageGibi,(400,700-hauteurGibi))
          win.blit(imageTerre,(275,700-hauteurArrivee-140))
          #pygame.draw.rect(win, (0, 255, 0), (0,700-hauteurArrivee, 1000, 5))
          pygame.display.update()

def rafraichissement():
    if run :
        drawGame()

def initcourse():
    global run, hauteurShadok, hauteurGibi
    run = True
    hauteurShadok = 0 #ligne départ
    hauteurGibi = 0   
    
def generiqueFin():
    clip = VideoFileClip('img/fin.mp4')
    clip.preview()
    pygame.quit()
    
def course():
    global run 
    bruit = pygame.mixer.music.load("img/decollage.ogg")
    pygame.mixer.music.play(1, 0.0)
    while run:
          calculS = Thread(target = fuseeS)
          calculS.start() 
    
          calculG = Thread(target = fuseeG)
          calculG.start()  
          
          maj=Thread(target = rafraichissement)
          maj.start()
          if VERBOSE :
              print("arrivee, shadok, gibi : " + str(hauteurArrivee) + " " + str(hauteurShadok) + " " + str(hauteurGibi)) 
          if hauteurGibi > hauteurArrivee or hauteurShadok > hauteurArrivee:
              run = False
    pygame.mixer.music.stop()
    if hauteurGibi>hauteurShadok:          
        wineur= 'gibis.'
    else :
        wineur='shadoks.'
    
    # Affichage du gagnant  
    bruit = pygame.mixer.music.load("img/pas.ogg")
    pygame.mixer.music.play(1, 1.0)
    
    wineur='La fusée la plus rapide sur cette distance est celle des ' + wineur
    text = fontpetit.render(wineur, True, BLUE)
    textRect = text.get_rect()
    textRect.center = (300, 650)
    textContinue = fontpetit.render('Touche "r" pour une nouvelle course, "q" pour quitter la simulation.', True, BLUE)
    textContinueRect = textContinue.get_rect()
    textContinueRect.center = (300, 700)
    while True:
        if VERBOSE :    
            print("calculS vivant ?"+str(calculS.is_alive()))
            print("calculG vivant ?"+str(calculG.is_alive()))
            print("mise à jour vivant ?"+str(maj.is_alive()))
        win.blit(text, textRect)
        win.blit(textContinue, textContinueRect)
        for event in pygame.event.get():
             if event.type == pygame.QUIT:
                 pygame.quit()
             if event.type == pygame.KEYUP :
                 if event.key == pygame.K_r :
                     pygame.mixer.music.stop()
                     choixArrivee()
                     if not modeTest :
                         rebour()
                     initcourse()
                     course()
                 if event.key == pygame.K_q :
                     if modeTest :
                         pygame.quit()
                     else :
                         generiqueFin()
        pygame.display.update()
        
if not modeTest :    
    sequenceIntro()

hauteurArrivee = 0
choixArrivee()
initcourse()
if not modeTest :    
    
    rebour()
course()
pygame.quit()

 
  
      